#include <avr\io.h>
#include <avr\interrupt.h>

#define F_CPU 16000000
#include <util/delay.h>
#include <string.h>

void pattern1()
{	int i,j;
	int pini_a[8] = {PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7};
	int pini_c[8] = {PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7};
	
	
	for (i=0; i<8; i++) 
			{
				PORTA |= (1 << pini_a[i]);
				_delay_ms(300);
				PORTA &= ~(1 << pini_a[i]);
			}
	
	for (j=0; j<8; j++) 
			{
				PORTC |= (1 << pini_c[j]);
				_delay_ms(300);
				PORTC &= ~(1 << pini_c[j]);
			}
}


void pattern2()
{	int i,j;
	int pini_a[8] = {PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7};
	int pini_c[8] = {PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7};
	
	
	for (i=0; i<8; i++) 
			{
				PORTA |= (1 << pini_a[i]);
				PORTA |= (1 << pini_a[7-i]);
				_delay_ms(300);
				PORTA &= ~(1 << pini_a[i]);
				PORTA &= ~(1 << pini_a[7-i]);
			}
	
	for (j=0; j<8; j++) 
			{
				PORTC |= (1 << pini_c[j]);
				PORTC |= (1 << pini_c[7-j]);
				_delay_ms(300);
				PORTC &= ~(1 << pini_c[j]);
				PORTC &= ~(1 << pini_c[7-j]);
			}
}

void pattern3(){
	int i;

	for(i = 0 ; i < 8 ; i ++)
	{
		PORTA |= (1<<i);
		_delay_ms(200);
		PORTC |= (1<<i);
		_delay_ms(200);
	}
	for(i = 0; i < 8; i++){	
		PORTA &= ~(1 << i);
		PORTC &= ~(1 << i);
		}
	

}


void pattern4(){
	int i,j;

	for(i = 0 ; i < 8 ; i ++)
	{
		PORTA |= (1<<rand()%7);
		_delay_ms(200);
		PORTA = 0x00;
	}
	
	for(j = 0 ; j < 8 ; j ++)
	{
		PORTC |= (1<<rand()%7);
		_delay_ms(200);
		PORTC = 0x00;
	}
}


int main(){
	
	DDRA = 0xFF;
	DDRC = 0xFF;
		
	
	while(1)
	{
		pattern1();
		pattern2();
		pattern3();
		pattern4();
			
	}
	
	return 0;
}
